
//#if defined (EOS60D)

#undef	ROT1_INIT
#define	ROT1_INIT	HIGH
#undef	ROT2_INIT
#define	ROT2_INIT	LOW
#undef	ROT3_INIT
#define	ROT3_INIT	LOW

/*
Emulation analog zur 70D : NICHT GETESTET!!!!!!
Sollte im Leise-Modus 1 laufen.
 Die Bezeichnung von ROT1 und ROT3  ist vertauscht!
 S5==MR1, S4==MR2, S6==MR3 

 Coil 1 und 2 werden immer gemeinsam aktiviert, Coil 1 beendet
   die Belichtung.
 Die Coil 2 Dauer zeigt die aktuelle Aktion:
  55 ms: Shoot
  ms: Shoot im LV (Leise 1)
  38ms: LV Start
  ms: LV Stopp
*/

// Start einer Aktion auerhalb des LV
//
sAction c1_L_Start[] = {			// Coil 2 aktiv
	{ 2 ms,  MR2 , HIGH },
	{ 8 ms,  MR1 , LOW  },
	{11 ms,  ROT2, HIGH },
	{11 ms,  ROT3, HIGH },
	{15 ms,  MR3 , LOW  },
	{18 ms,  ROT3, LOW  },
	//
	// In diesem Zustand kommt bei LV1-Start das C2_H bei 38 ms.
	// Fr normale Auslsung (C2_H bei 55 ms) mssen die nchsten 
	//  Flanken auf jeden Fall schon ausgefhrt werden.
	/*
	{23 ms,  ROT3, HIGH },  // (das erste wrde beim LV-Start nicht stren)
	{33 ms,  ROT2, LOW  },
	{36 ms,  ROT1, LOW  },
	*/
	// Die nchsten 3 Aktionen sind hinter 39 ms versetzt, um zu vermeiden,
	//  dass sie beim LV-Start, wo sie erst beim nchsten Ereignis folgen, ausgefhrt werden.
	//  Die Kamera wartet spter endlos darauf, wogegen auch keine Korrektur in EnterLV hilft.
	// Fr die normale Auslsung ist das kein generelles Problem, weil die
	//  Kamera mit C2_H wartet. Mit 41 ms fr die nchste Aktion sollte das C2_H noch bei 49 ms kommen.
	// (Zur besseren Unterscheidung von anderen C2_H knnte auch noch weiter verzgert werden)
	//
	{41 ms,  ROT3, HIGH },
	{41 ms,  ROT2, LOW  },
	{42 ms,  ROT1, LOW  },

	HALT_ACTION,		// weiter gehts wenn C2 Hi die Belichtung startet
};


// Beim Start des LV lst Coil 2 schon nach 38 ms.
// Wenn anhand der C2_L Dauer vom normalen Shoot unterschieden wird, sind die ROT-Signale
//  schon zu weit, weil der Motor im LV-Leise-1 das Schlieen noch nicht vorspannt.
//  Deshalb werden die ROT Flanken in c1_L_Start verzgert.
//
sAction c2_H_EnterLV[] = {	
	{3 ms,   OPT2, LOW },	// -> Curtain ffnet und nach 4 ms geht OPT2 Lo. Bei sehr kurzen Belichtungen (<6ms, 1/200) wird die Aktion vorgezogen.
	{4 ms,   OPT2, HIGH },	// Dann folgt noch ein kurzer Puls, der mit 1 ms Auflsung nicht immer zu sehen ist!!!!!!!
	{5 ms,   OPT2, LOW },
	STOP_ACTION,
};

sAction c1_H_EnterLV[] = {	// Coil 1 wird zwar geschaltet, aber der Curtain ist nicht aufgezogen und schliet nicht
	STOP_ACTION,
};


//
// Fortsetzung des regulren Shoot-Timings nach Coil-2 Hi und spter C1_H
//
sAction c2_H_FinishShoot[] = {		// Coil 2 wird inaktiv
	{3 ms,   OPT2, LOW },	// -> Curtain ffnet und nach 2-3 ms geht OPT2 Lo.
	{4 ms,   OPT2, HIGH },	// Dann folgt noch ein kurzer Puls, der mit 1 ms Auflsung nicht immer zu sehen ist!!!!!!!
	{5 ms,   OPT2, LOW },
	LONGWAIT_ACTION,	// hier warten, bis Coil 1 Hi wird und die Belichtung beendet
#define c1_H_FinishShoot (c2_H_FinishShoot + 4)	
	// Coil 1 wird inaktiv: 
	// Curtain von Coil 2 hat schon vorher geffnet und 4 ms danach ging OPT2 Lo - falls die Belichtung
	//  > 5 ms war. Bei sehr kurzen Belichtungen wird der letzte Eintrag in c1_L_Start aber nicht 
	//  mehr ausgefhrt und deshalb hier ggf. nachgezogen! (Perfekt wre Multi-Action!)
	// Klappt auch mit 1/2000, obwohl die Flanken dann sehr schnell kommen.
	// Vmtl. ist es auch ok, OPT2_H sofort nach C2_H auszufhren.
	{ 3 ms,  OPT1, LOW  },
	{ 4 ms,  OPT1, HIGH },
	{ 5 ms,  OPT1, LOW  },
	{ 6 ms,  MR1, HIGH }, 
	{ 6 ms,  MR3 , HIGH }, 
	{ 33 ms, OPT1, HIGH },    // wg. Opt-Power=Off bei 15 ms ist der Zeitpunkt nicht zu erkennen,
	{ 33 ms, OPT2, HIGH },	  //  aber die Curtains werden wieder in Startpos. gebracht!
	{36 ms,  MR3 , LOW  }, 
	{40 ms,  MR3 , HIGH }, 
	{ 44 ms, ROT1, HIGH },
	{ 44 ms, ROT2, HIGH },
	{59 ms,  MR1 , LOW  }, 
	{67 ms,  MR1 , HIGH }, 
	{67 ms,  MR2 , LOW  }, 
	{ 68 ms, ROT2, LOW  },
	{ 81 ms, ROT3, LOW  },
	STOP_ACTION,
};


// Im LV1 wird die ShootLV-Sequenz direkt ausgefhrt:
//
sAction c1_L_StartInLV[] = {	    // Timing fr Shoot im LV1	
//*
	{0 ms,   OPT1, HIGH },
	{0 ms,   ROT3, HIGH  },
	{0 ms,   ROT2, HIGH  },
	{0 ms,   ROT2, HIGH  },
	{0 ms,   ROT1, LOW  },	// soweit unntig */
	{ 5 ms,  ROT3, HIGH },
	{15 ms,  ROT2, LOW  },
	{19 ms,  ROT1, LOW  },
	HALT_ACTION,		// weiter gehts mit C1 Hi sehr hnlich wie Shoot ohne LV
};

// Fortsetzung des LVShoot-Timings nach Coil-1/2 Hi
//
sAction c2_H_FinishLVShoot[] = {			// Coil 2 wird inaktiv
	LONGWAIT_ACTION,				// hier warten, bis Coil 1 Hi wird und den Ablauf fortsetzt
#define c1_H_FinishLVShoot (c2_H_FinishLVShoot + 1)	
	{ 3 ms,  OPT1, LOW  },
	{ 4 ms,  OPT1, HIGH },
	{ 5 ms,  OPT1, LOW  },
	{ 24 ms, ROT1, HIGH },
	{ 24 ms, ROT2, HIGH },
	{ 48 ms, ROT2, LOW  },
	{ 60 ms, ROT3, LOW  },
	{ 60 ms, OPT1, HIGH },    // wg. Opt-Power=Off ist der Zeitpunkt nicht zu erkennen,
	{ 60 ms, OPT2, HIGH },	  //  aber die Curtains werden wieder in Startpos. gebracht!
  	STOP_ACTION,
};

// Das LV-Ende wurde am Coil-1 oder -2 Hi Timing erkannt. Dann folgt:
//
sAction c2_H_LeaveLV[] = {
	{ 3 ms,  OPT1, LOW  },
	{ 4 ms,  OPT1, HIGH },
	{ 5 ms,  OPT1, LOW  },
	{ 6 ms,  MR1 , HIGH },
	{ 6 ms,  MR3 , HIGH },
	{37 ms,  MR3 , LOW  },
	{41 ms,  MR3 , HIGH },
	{ 44 ms, ROT1, HIGH },
	{ 44 ms, ROT2, HIGH },
	{61 ms,  MR1 , LOW  },
	{ 68 ms, ROT2, LOW  },
	{69 ms,  MR1 , HIGH },
	{69 ms,  MR2 , LOW  },
	{ 82 ms, ROT3, LOW  },
	{ 82 ms, OPT1, HIGH },    // wg. Opt-Power=Off ist der Zeitpunkt nicht zu erkennen,
	{ 82 ms, OPT2, HIGH },	  //  aber die Curtains werden wieder in Startpos. gebracht!
	STOP_ACTION,						// fertig
};
#define c1_H_LeaveLV	c2_H_LeaveLV		// mit oder ohne Coil2: fr Coil1 identisch

///////////////////////////////////////
/*  60D Coil-Pulsdauer (LV im Leise-Modus 1):
	Modus	   Coil 1  Coil 2

	Shoot      55+t     55	  // wird durch die zurckgestellte ROT-Signale ggf. verzgert!	 
	Shoot LV   58+t     58
	Enter LV    42      38
	ReEnter LV  38      34	  
	Leave LV    22      22

	Die Zeiten knnen durch Verschieben der ROT-Signale verndert/angepasst werden! 
*/

// --> Grenzwerte zur Unterscheidung der Funktion bei C1_H:
#define HiLIMIT_C2_ENTER_LV	((38+4) ms)
#define HiLIMIT_C2_REENTER_LV	((34+2) ms)
#define HiLIMIT_C2_LEAVE_LV	((22+6) ms)
#define LoLIMIT_C2_LVSHOOT	((58-0) ms)   // Shoot kann bis 57+ gehen

//#define IsInWindow_LVShoot(dt)   (dt >= LoLIMIT_C2_LVSHOOT)
#define IsInWindow_EnterLV(dt)   (dt <= HiLIMIT_C2_ENTER_LV  &&  dt >= HiLIMIT_C2_LEAVE_LV)
#define IsInWindow_ReEnterLV(dt) (dt <= HiLIMIT_C2_REENTER_LV  &&  dt >= HiLIMIT_C2_LEAVE_LV)
#define IsInWindow_LeaveLV(dt)   (dt <= HiLIMIT_C2_LEAVE_LV)

//
// Erste sAction Liste auswhlen fr ein Coil-Start Ereignis
// In allen Modi wird nach Shoot im LV wieder ein EnterLV ausgefhrt, so dass
//  daran immer zu erkennen ist, ob LV aktiv ist.
//
/* Nicht verwendet (s. Loop()):
inline sAction* SelectStartAction()
{
  if (actionPtr == c2_H_EnterLV) {	// im LV?
//PRINTLN("c1_L_StartInLV");
    return c1_L_StartInLV;
  }
  else {
//PRINTLN("c1_L_Start");
    return c1_L_Start;
  }
}
*/
// Nchste sAction Liste auswhlen fr die Fortsetzung eines Coil-Start Ereignisses,
//  das jetzt nach dt Millisekunden durch ein Coil-Ende Signal abgeschlossen wurde.
//
inline sAction* SelectFinishAction(unsigned long dt)
{
//PRINT_1000(dt);
  if (actionPtr == c1_L_StartInLV  &&	// Re-EnterLV tritt in Emu auch mit c1L=22ms auf! Deshalb hier Leave nur zulassen, wenn im LV!
      dt <= HiLIMIT_C2_LEAVE_LV) {		// LV-Stop (17ms)
//PRINTLN("c2_H_LeaveLV");
    return c2_H_LeaveLV;
  }
  else if (dt < HiLIMIT_C2_ENTER_LV) {		// (Re-)EnterLV (38 ms)
//PRINTLN("c2_H_EnterLV");
    return c2_H_EnterLV;
  }
  else if (dt > LoLIMIT_C2_LVSHOOT) {		// Auslsen im LV (58ms)
//PRINTLN("c2_H_FinishLVShoot");
    return c2_H_FinishLVShoot;
  }
  else {																	// (700D 68 ms, 600D 77 ms:) nicht-LV-Shoot
//PRINTLN("c2_H_FinishShoot");
    return c2_H_FinishShoot;			// Shoot (49++ ms, verzgert)
  }
}

//#endif // EOS60D --------------------------------------------
