//#ifdef EOS60D_alt

#undef	ROT1_INIT
#define	ROT1_INIT	HIGH
#undef	ROT2_INIT
#define	ROT2_INIT	LOW
#undef	ROT3_INIT
#define	ROT3_INIT	LOW


sAction c1_L_Start[] = {			// Coil 2 aktiv
	{0 ms,   OPT1, HIGH },
	{0 ms,   OPT2, HIGH },
	{0 ms,   ROT2, LOW  },
	{0 ms,   ROT3, LOW  },
	{0 ms,   ROT1, HIGH },	// soweit unntig
	{ 2 ms,  MR2 , HIGH },
	{ 8 ms,  MR1 , LOW  },
	{11 ms,  ROT2, HIGH },
	{11 ms,  ROT3, HIGH },
	{15 ms,  MR3 , LOW  },
	{18 ms,  ROT3, LOW  },
	// In diesem Zustand kommt bei LV1-Start C2_H, normal erst nach 38 ms.
	// Zumindest die nchste Flanke wird in der Emu. des LV-Start aber auf jeden
	//  Fall schon ausgefhrt, was die Kamera aber nicht strt.
	{23 ms,  ROT3, HIGH },
	// Die beiden folgenden Aktionen sind um 10 ms nach hinten versetzt, um zu vermeiden,
	//  dass sie beim LV-Start, wo sie erst beim nchsten Ereignis folgen, ausgefhrt werden.
	//  Fr die normale Auslsung scheint das kein Problem zu sein, aber
	//  wenn sie beim LV-Start ausgefhrt werden, wartet die Kamera spter endlos darauf, 
	//  wogegen auch keine Korrektur in EnterLV hilft.
	{43 ms,  ROT2, LOW  },
	{46 ms,  ROT1, LOW  },
	HALT_ACTION,		// weiter gehts, wenn C2 Hi nach 55 ms die Belichtung startet (bei der Spiegelvorauslsung hlt der Ablauf hier an)
};

//
// Fortsetzung des regulren Shoot-Timings nach Coil-2 Hi und spter C1_H
//
sAction c2_H_FinishShoot[] = {		// Coil 2 wird inaktiv
	{3 ms,   OPT2, LOW },	// -> Curtain ffnet und nach 2-3 ms geht OPT2 Lo.
	{4 ms,   OPT2, HIGH },	// Dann folgt noch ein kurzer Puls, der mit 1 ms Auflsung nicht immer zu sehen ist!!!!!!!
	{5 ms,   OPT2, LOW },
	LONGWAIT_ACTION,	// hier warten, bis Coil 1 Hi wird und die Belichtung beendet
#define c1_H_FinishShoot (c2_H_FinishShoot + 4)	
	// Coil 1 wird inaktiv: 
	// Curtain von Coil 2 hat schon vorher geffnet und 4 ms danach ging OPT2 Lo - falls die Belichtung
	//  > 5 ms war. Bei sehr kurzen Belichtungen wird der letzte Eintrag in c1_L_Start aber nicht 
	//  mehr ausgefhrt und deshalb hier ggf. nachgezogen! (Perfekt wre Multi-Action!)
	// Klappt auch mit 1/2000, obwohl die Flanke dann sehr schnell kommen.
	// Vmtl. ist es auch ok, OPT2_H sofort nach C2_H auszufhren.
	{ 3 ms,  OPT1, LOW  },
	{ 4 ms,  OPT1, HIGH },
	{ 5 ms,  OPT1, LOW  },
	{ 6 ms,  MR1 , HIGH }, 
	{ 6 ms,  MR3 , HIGH }, 
	{ 33 ms, OPT1, HIGH },    // wg. Opt-Power=Off bei 15 ms ist der Zeitpunkt nicht zu erkennen,
	{ 33 ms, OPT2, HIGH },	  //  aber die Curtains werden wieder in Startpos. gebracht!
	{36 ms,  MR3 , LOW  }, 
	{40 ms,  MR3 , HIGH }, 
	{ 44 ms, ROT1, HIGH },
	{ 44 ms, ROT2, HIGH },
	{59 ms,  MR1 , LOW  }, 
	{67 ms,  MR1 , HIGH }, 
	{67 ms,  MR2 , LOW  }, 
	{ 68 ms, ROT2, LOW  },
	{ 81 ms, ROT3, LOW  },
	STOP_ACTION,
};


// Im LV0 wird vor Shoot zuerst der LV beendet mit C2_H = 22 ms wie bei LV-Stop (Spiegel bleibt aber offen!).
//  Die ROT kommen aber 22 ms frher, weil der Motor nicht anhlt. Ggf. muss dafr doch der LV-Zustand
//  geloggt werden und dazu noch der LeaveLV Zeitpunkt.
// Im LV1 wird die ShootLV-Sequenz direkt ausgefhrt:
//
sAction c1_L_StartInLV[] = {	    // Timing fr Shoot im LV1	
	{0 ms,   OPT1, HIGH },
	{0 ms,   OPT2, LOW  },
	{0 ms,   ROT1, HIGH  },
	{0 ms,   ROT2, HIGH  },
	{0 ms,   ROT3, LOW  },	// soweit unntig
	{ 5 ms,  ROT3, HIGH },
	{15 ms,  ROT2, LOW  },
	{19 ms,  ROT1, LOW  },
	HALT_ACTION,		// weiter gehts mit C1 Hi sehr hnlich wie Shoot ohne LV
};

//* Test Leise1_1:
#define c1_H_FinishLVShoot c1_H_FinishShoot 
#define c2_H_FinishLVShoot c2_H_FinishShoot 
/*/
// Fortsetzung des LVShoot-Timings nach Coil-1/2 Hi
// !!! Klappt auch mit c2_H_FinishShoot: Spiegelsignale werden ignoriert. !!!
//
sAction c2_H_FinishLVShoot[] = {			// Coil 2 wird inaktiv
      //{4 ms,    OPT2, HIGH },	// -> Curtain ffnet (OPT2 war gar nicht LOW)
	LONGWAIT_ACTION,				// hier warten, bis Coil 1 Hi wird und den Ablauf fortsetzt
#define c1_H_FinishLVShoot (c2_H_FinishLVShoot + 1)	
	{ 3 ms,  OPT1, LOW  },
	{ 4 ms,  OPT1, HIGH },
	{ 5 ms,  OPT1, LOW  },
	{ 24 ms, ROT1, HIGH },
	{ 24 ms, ROT2, HIGH },
	{ 48 ms, ROT2, LOW  },
	{ 60 ms, ROT3, LOW  },
	{ 60 ms, OPT1, HIGH },    // wg. Opt-Power=Off ist der Zeitpunkt nicht zu erkennen,
	{ 60 ms, OPT2, HIGH },	  //  aber die Curtains werden wieder in Startpos. gebracht!
	STOP_ACTION,
};
//*/

// Beim Start des LV lst Coil 2 schon nach 38 ms (ohne Coil-1 4 ms spter).
// Wenn anhand der C2_L Dauer vom normalen Shoot unterschieden wird, sind die ROT-Signale
//  schon zu weit, weil der Motor im LV-Leise-1 das Schlieen noch nicht vorspannt.
//  Bei der 6D scheint das zunchst kein Problem zu sein, aber beim Shoot im oder Stop des LV 
//  gibts Error 20. Die Pegel hier zu korrigieren geht aber nicht!
sAction c2_H_EnterLV[] = {	
	//{0 ms,    ROT2, HIGH}, // korrigieren: wurde in c1_L_Start schon gesetzt
	//{0 ms,    ROT1, HIGH}, //  HILFT ABER NICHT! --> c1_L_Start
	{3 ms,   OPT2, LOW },	// -> Curtain ffnet und nach 4 ms geht OPT2 Lo. Bei sehr kurzen Belichtungen (<6ms, 1/200) wird die Aktion vorgezogen.
	{4 ms,   OPT2, HIGH },	// Dann folgt noch ein kurzer Puls, der mit 1 ms Auflsung nicht immer zu sehen ist!!!!!!!
	{5 ms,   OPT2, LOW },
	STOP_ACTION,
};

sAction c1_H_EnterLV[] = {	// Coil 1 wird zwar geschaltet, aber der Curtain ist nicht aufgezogen und schliet nicht
	STOP_ACTION,
};


// Das LV-Ende wurde am Coil-1 oder -2 Hi Timing erkannt. Dann folgt:
//
sAction c2_H_LeaveLV[] = {
	{ 3 ms,  OPT1, LOW  },
	{ 4 ms,  OPT1, HIGH },
	{ 5 ms,  OPT1, LOW  },
	{ 6 ms,  MR1 , HIGH },
	{ 6 ms,  MR3 , HIGH },
	{37 ms,  MR3 , LOW  },
	{41 ms,  MR3 , HIGH },
	{ 44 ms, ROT1, HIGH },
	{ 44 ms, ROT2, HIGH },
	{61 ms,  MR1 , LOW  },
	{ 68 ms, ROT2, LOW  },
	{69 ms,  MR1 , HIGH },
	{69 ms,  MR2 , LOW  },
	{ 82 ms, ROT3, LOW  },
	{ 82 ms, OPT1, HIGH },    // wg. Opt-Power=Off ist der Zeitpunkt nicht zu erkennen,
	{ 82 ms, OPT2, HIGH },	  //  aber die Curtains werden wieder in Startpos. gebracht!
	STOP_ACTION,						// fertig
};
#define c1_H_LeaveLV	c2_H_LeaveLV		// mit oder ohne Coil2: fr Coil1 identisch

///////////////////////////////////////
/*  60D Coil-Timing (LV im Leise-Modus 1):
	Modus	   Coil 1  Coil 2

	Shoot      55+t     55	  //bis ber 58 in der Emu!)
	Shoot LV   58+t     58
	Enter LV    42      38
	ReEnter LV  38      34	  // 22 in der Emu!
	Leave LV    22      22

	Die Zeiten knnen im Emu sehr stark abweichen! 
*/

// --> Grenzwerte zur Unterscheidung der Funktion bei C1_H:
#define HiLIMIT_C2_ENTER_LV	((38+4) ms)
#define HiLIMIT_C2_REENTER_LV	((34+2) ms)
#define HiLIMIT_C2_LEAVE_LV	((22+6) ms)
#define LoLIMIT_C2_LVSHOOT	((58-0) ms)   // Shoot kann bis 57+ gehen

//#define IsInWindow_LVShoot(dt)   (dt >= LoLIMIT_C2_LVSHOOT)
#define IsInWindow_EnterLV(dt)   (dt <= HiLIMIT_C2_ENTER_LV  &&  dt >= HiLIMIT_C2_LEAVE_LV)
#define IsInWindow_ReEnterLV(dt) (dt <= HiLIMIT_C2_REENTER_LV  &&  dt >= HiLIMIT_C2_LEAVE_LV)
#define IsInWindow_LeaveLV(dt)   (dt <= HiLIMIT_C2_LEAVE_LV)

//
// Erste sAction Liste auswhlen fr ein Coil-Start Ereignis
// In allen Modi wird nach Shoot im LV wieder ein EnterLV ausgefhrt, so dass
//  daran immer zu erkennen ist, ob LV aktiv ist.
//
/* Nicht verwendet (s. Loop()):
inline sAction* SelectStartAction()
{
  if (actionPtr == c2_H_EnterLV) {	// im LV?
//PRINTLN("c1_L_StartInLV");
    return c1_L_StartInLV;
  }
  else {
//PRINTLN("c1_L_Start");
    return c1_L_Start;
  }
}
*/
// Nchste sAction Liste auswhlen fr die Fortsetzung eines Coil-Start Ereignisses,
//  das jetzt nach dt Millisekunden durch ein Coil-Ende Signal abgeschlossen wurde.
//
inline sAction* SelectFinishAction(unsigned long dt)
{
//PRINT_1000(dt);
  if (actionPtr == c1_L_StartInLV  &&	// Re-EnterLV tritt in Emu auch mit c1L=22ms auf! Deshalb hier Leave nur zulassen, wenn im LV!
      dt <= HiLIMIT_C2_LEAVE_LV) {		// LV-Stop (22ms)
//PRINTLN("c2_H_LeaveLV");
    return c2_H_LeaveLV;
  }
  else if (dt < HiLIMIT_C2_ENTER_LV) {		// (Re-)EnterLV (38 ms)
//PRINTLN("c2_H_EnterLV");
    return c2_H_EnterLV;
  }
  else if (dt > LoLIMIT_C2_LVSHOOT) {		// Auslsen im LV (58ms)
//PRINTLN("c2_H_FinishLVShoot");
    return c2_H_FinishLVShoot;
  }
  else {																	// (700D 68 ms, 600D 77 ms:) nicht-LV-Shoot
//PRINTLN("c2_H_FinishShoot");
    return c2_H_FinishShoot;			// Shoot (55ms)
  }
}

//#endif 
