//#ifdef EOS6D // oder EOS6Dii

sAction c1_L_Start[] = {			// Coil 2 aktiv
	{0 ms,   OPT1, HIGH },
	{0 ms,   OPT2, HIGH },
	{0 ms,   ROT1, LOW  },
	{0 ms,   ROTX, LOW  },
#ifdef EOS6Dii
	{ 1 ms,  MR1 , LOW  },
	{ 4 ms,  ROT1, HIGH },
	{ 5 ms,  ROTX, HIGH },
	{11 ms,  ROTX, LOW  },
	{15 ms,  ROTX, HIGH },
	{15 ms,  ROT1, LOW  },
	{20 ms,  MR2 , HIGH },
	{21 ms,  ROT2, LOW  },
#else
	{ 5 ms,  ROT1, HIGH },
	{ 6 ms,  ROTX, HIGH },
	{ 9 ms,  MR3 , LOW  },
	{ 9 ms,  MR2 , HIGH },
	{11 ms,  MR3 , HIGH },
	{12 ms,  MR1 , LOW  },
	{14 ms,  ROTX, LOW  },
	{17 ms,  ROT1, LOW  },
	{18 ms,  ROTX, HIGH },
	{24 ms,  ROT2, LOW  },
#endif // 6Dii
	HALT_ACTION,		// weiter gehts wenn C2 Hi die Belichtung startet (bei der Spiegelvorauslsung hlt der Ablauf hier an)
};


// Start fr den LV:  Coil 2 ohne Coil 1 aktiv
//
sAction c2_L_StartForLV[] = {	
	{0 ms,   OPT1, HIGH },
	{0 ms,   OPT2, HIGH },
	{0 ms,   ROT1, LOW  },
	{0 ms,   ROTX, LOW  },
#ifdef EOS6Dii
	{0 ms,   MR1 , LOW  },
	{8 ms,   ROTX, HIGH  },
	{9 ms,   ROT1, HIGH  },
	{18 ms,  MR2 , HIGH },
#else
	{8 ms,   ROTX, HIGH  },	// spter als bei Shoot!
	{9 ms,   ROT1, HIGH  },	//  dito
	{ 9 ms,  MR3 , LOW  },
	{ 9 ms,  MR2 , HIGH },
	{11 ms,  MR3 , HIGH },
	{12 ms,  MR1 , LOW  },
#endif // 6Dii
	{21 ms,  ROTX, LOW  },  // spter als bei Shoot!
	HALT_ACTION,		// weiter gehts mit C2 Hi
};

// Fortsetzung des regulren Shoot-Timings nach Coil-1/2 Hi
// 
// Zuerst wird Coil 2 inaktiv und die Pulsfolge auf Opt2 wird erzeugt.
// Danach wird gewartet, bis Coil-1 Hi das Ende der Belichtung anzeigt und die Opt1-
//  und weiteren Signale ausgegeben werden.
// Bei kurzen Belichtungen ist die Opt2-Folge noch nicht regulr abgearbeitet, wenn
//  C1_H kommt und wird dann kompakt ausgegeben. Das scheint kein Problem zu sein.
// Die 6Dii gibt ab 1/3200s Err30 aus. Dagegen hilft auch nicht, die
//  Opt2-Folge komplett bei 0 ms auszugeben (was generell aber ok ist!).
//  Es hilft auch nicht, die Opt2-Folge nach dem LONGWAIT nochmal auszugeben (was 
//   generell aber auch ok ist (getestet mit der 6Dii)).
//  Das Problem liegt darin, dass C2_H gar nicht mehr bearbeitet wird, wenn C1_H zu
//   frh kommt, weil in trigger1_interrupt() angenommen wird, dass C1_H und C2_H
//   zusammen kommen und LeaveLV anzeigen.
//
sAction c2_H_FinishShoot[] = {	// Coil 2 wird inaktiv
	{3 ms,   OPT2, LOW },	// -> Curtain ffnet und nach 4 ms geht OPT2 Lo. Bei sehr kurzen Belichtungen (<6ms, 1/200) wird die Aktion vorgezogen.
	{5 ms,   OPT2, HIGH },	// Dann folgt noch ein kurzer Puls, der mit 1 ms Auflsung nicht immer zu sehen ist!!!!!!!
	{6 ms,   OPT2, LOW },	// (auch Timing 0,0,0 ist ok!)
	LONGWAIT_ACTION,	// hier warten, bis Coil 1 Hi wird und die Belichtung beendet
#define c1_H_FinishShoot (c2_H_FinishShoot + 4)	
	// Coil 1 wird inaktiv: 
	{ 5 ms,  OPT1, LOW  },
	{ 7 ms,  OPT1, HIGH },
	{ 8 ms,  OPT1, LOW  },
#ifdef EOS6Dii
	{ 18 ms, MR2 , LOW  },
	{ 22 ms, ROT2, HIGH },
	{ 23 ms, ROT1, HIGH },
	{ 36 ms, MR1 , HIGH }, 
	{ 68 ms, ROT1, LOW  },
	{ 76 ms, ROTX, LOW  },
	{ 76 ms, OPT1, HIGH },    // wg. Opt-Power=Off ist der Zeitpunkt nicht zu erkennen,
	{ 76 ms, OPT2, HIGH },	  //  aber die Curtains werden wieder in Startpos. gebracht!
#else
	{ 9 ms,  MR1 , HIGH }, 
	{41 ms,  MR3 , LOW  },
	{52 ms,  MR3 , HIGH }, 
	{54 ms,  MR2 , LOW  },
	{ 61 ms, ROT1, HIGH },
	{ 62 ms, ROT2, HIGH },
	{108 ms, ROT1, LOW  },
	{116 ms, ROTX, LOW  },
	{116 ms, OPT1, HIGH },    // wg. Opt-Power=Off ist der Zeitpunkt nicht zu erkennen,
	{116 ms, OPT2, HIGH },	  //  aber die Curtains werden wieder in Startpos. gebracht!
#endif // 6Dii
	STOP_ACTION,
};

/////////////////////////////////////
// Start nach Shoot im LV:  Coil 2 ohne Coil 1 aktiv
//
sAction c2_L_StartInLVForLV[] = {	
	{8 ms,   ROTX, HIGH  },  // spter als bei Shoot!
	{9 ms,   ROT1, HIGH  },
	{21 ms,  ROTX, LOW  },
	HALT_ACTION,		// weiter gehts mit C2 Hi
};


//
// Start in LV: Coil 1+2 aktiv. Wird fr LV-Shoot und LV-Stop ausgef.
sAction c1_L_StartInLV[] = {			// Coil 2 aktiviert im LV
	{ 4 ms,  ROTX, HIGH },
	{ 5 ms,  ROT1, LOW  },
	{12 ms,  ROT2, LOW  }, // 7ms nach R1_L
	HALT_ACTION,
};

// Fortsetzung des LVShoot-Timings nach Coil-1/2 Hi
// !!! Klappt auch mit c2_H_FinishShoot: Spiegelsignale werden ignoriert. !!!
//
sAction c2_H_FinishLVShoot[] = {			// Coil 2 wird inaktiv
      //{4 ms,    OPT2, HIGH },	// -> Curtain ffnet (OPT2 war gar nicht LOW)
	LONGWAIT_ACTION,				// hier warten, bis Coil 1 Hi wird und den Ablauf fortsetzt
#define c1_H_FinishLVShoot (c2_H_FinishLVShoot + 1)	
	{ 4 ms,  OPT1, LOW  },
	{ 6 ms,  OPT1, HIGH },
	{ 7 ms,  OPT1, LOW  },
	{ 58 ms, ROT1, HIGH },
	{ 60 ms, ROT2, HIGH },
	{104 ms, ROT1, LOW  },
	{112 ms, ROTX, LOW  },
	{116 ms, OPT1, HIGH },    // wg. Opt-Power=Off ist der Zeitpunkt nicht zu erkennen,
	{116 ms, OPT2, HIGH },	  //  aber die Curtains werden wieder in Startpos. gebracht!
	STOP_ACTION,
};


// Beim Start des LV lst Coil 2 schon nach 50 ms (ohne Coil-1 Signal).
// Wenn anhand der C2_L Dauer vom normalen Shoot unterschieden wird, sind die ROT-Signale
//  schon zu weit, weil der Motor im LV-Leise-1 das Schlieen noch nicht vorspannt.
//  Das scheint zunchst kein Problem zu sein, aber beim Shoot im oder Stop des LV 
//  gibts Error 20. Die Pegel hier zu korrigieren geht aber nicht!
sAction c2_H_EnterLV[] = {	
	//{0 ms,    ROT2, HIGH}, // korrigieren: wurde in c1_L_Start schon gesetzt
	//{0 ms,    ROT1, HIGH}, // ..
	//{0 ms,    ROTX, LOW }, // ..
	{4 ms,   OPT2, LOW },	// -> Curtain ffnet und nach 4 ms geht OPT2 Lo. Bei sehr kurzen Belichtungen (<6ms, 1/200) wird die Aktion vorgezogen.
	{7 ms,   OPT2, HIGH },	// Dann folgt noch ein kurzer Puls, der mit 1 ms Auflsung nicht immer zu sehen ist!!!!!!!
	{8 ms,   OPT2, LOW },
	STOP_ACTION,
};
#define c1_H_EnterLV c2_H_EnterLV

// Nachdem das LV-Ende am Coil-2 Hi Timing erkannt wurde, mssen/knnen(?) 
//  die ROT-Pegel noch korrigiert werden, die hier frher kommen mssen,
//  aber noch auf dem Stand der reg. Auslsung nach 28 ms sind:
//
sAction c2_H_LeaveLV[] = {
	{ 4 ms,  OPT1, LOW  },
	{ 6 ms,  OPT1, HIGH },
	{ 7 ms,  OPT1, LOW  },
#ifdef EOS6Dii
	{ 25 ms, ROT2, HIGH },
	{ 26 ms, ROT1, HIGH },
	{ 31 ms, MR2 , LOW  },
	{ 64 ms, MR1 , HIGH }, 
	{ 86 ms, ROT1, LOW  },
	{ 94 ms, ROTX, LOW  },
	{ 94 ms, OPT1, HIGH },    // wg. Opt-Power=Off ist der Zeitpunkt nicht zu erkennen,
	{ 94 ms, OPT2, HIGH },	  //  aber die Curtains werden wieder in Startpos. gebracht!
#else
	{ 9 ms,  MR1 , HIGH }, 
	{41 ms,  MR3 , LOW  },
	{52 ms,  MR3 , HIGH }, 
	{54 ms,  MR2 , LOW  },
	{61 ms,  ROT1, HIGH },
	{62 ms,	 ROT2, HIGH },
	{107 ms, ROT1, LOW  },
	{114 ms, ROTX, LOW  },
	{116 ms, OPT1, HIGH },    // wg. Opt-Power=Off ist der Zeitpunkt nicht zu erkennen,
	{116 ms, OPT2, HIGH },	  //  aber die Curtains werden wieder in Startpos. gebracht!
#endif // 6Dii
	STOP_ACTION,						// fertig
};
#define c1_H_LeaveLV	c2_H_LeaveLV		// ohne Coil2: fr Coil1 identisch

///////////////////////////////////////
/*  6D Coil-Timing (LV im Leise-Modus 1):
	Modus	   Coil 1   Coil 2    6Dii_C2  6Dii_C2   
						R2_L +
	Shoot      52+t-1   52         50        37.5	Verlngert sich fr groe Blendenwerte!!!  
	Shoot LV   56+t-1   54..56     52.5	 39
	Enter LV    --      50	       38.5	 -
	ReEnter LV  --      36..38     40.5      -
	Leave LV    28      27..28     27        14.5

	C1 wird fr (Re-)EnterLV nicht aktiviert. Da C2 immer zeitgleich mit C1 startet
	 wird C2_H als Basissignal verwendet!
*/

// --> Grenzwerte zur Unterscheidung der Funktion bei C1_H:
#ifdef EOS6Dii
#define HiLIMIT_C2_ENTER_LV	((39+1) ms)
#define HiLIMIT_C2_REENTER_LV	((40+2) ms)
#define HiLIMIT_C2_LEAVE_LV	((28+6) ms)	// hngt davon ab, wie schnell der Motor luft: ~= R2_L + 15ms
#define LoLIMIT_C2_LVSHOOT	((52-1) ms)
#else
#define HiLIMIT_C2_ENTER_LV	((50+1) ms)	// 6Dii: nur 43ms
#define HiLIMIT_C2_REENTER_LV	((38+2) ms)	// 
#define HiLIMIT_C2_LEAVE_LV	((28+6) ms)	// hngt davon ab, wie schnell der Motor luft: ~= R2_L + 15ms
#define LoLIMIT_C2_LVSHOOT	((54-1) ms)
#endif // 6Dii
#define HiLIMIT_C1_LEAVE_LV	HiLIMIT_C2_LEAVE_LV

#define IsInWindow_LVShoot(dt)   (dt >= LoLIMIT_C2_LVSHOOT)
#define IsInWindow_EnterLV(dt)   (dt <= HiLIMIT_C2_ENTER_LV  &&  dt >= HiLIMIT_C2_LEAVE_LV)
#define IsInWindow_ReEnterLV(dt) (dt <= HiLIMIT_C2_REENTER_LV  &&  dt >= HiLIMIT_C2_LEAVE_LV)
#define IsInWindow_LeaveLV(dt)   (dt <= HiLIMIT_C1_LEAVE_LV)

// Erste sAction Liste auswhlen fr ein Coil-Start Ereignis
//
inline sAction* SelectStartAction()
{
  if (digitalRead(TRIGGER1) == TRIGGER1_ACTIVE) {   // auch Coil 1 ist aktiv: Auslsen oder LV-Stop
    if (actionPtr == c2_H_EnterLV) {		    //  sind wir im LV?
      //PRINTLN("c1_L_StartInLV");
      return c1_L_StartInLV;
    }
    else {
      //PRINTLN("c1_L_Start");
      return c1_L_Start;
    }
  }
  else {		  // ohne Coil 1: LV-Start - ist innerhalb nach LVShoot oder LV-ReEnter mglich
    if (actionPtr == c2_H_EnterLV  ||  actionPtr == c2_H_FinishLVShoot) {		  
      //PRINTLN("c2_L_StartInLVForLV");
      return c2_L_StartInLVForLV;
    }
    else {
      //PRINTLN("c2_L_StartForLV");
      return c2_L_StartForLV;
    }
  }
}

// Nchste sAction Liste auswhlen fr die Fortsetzung eines Coil-Start Ereignisses,
//  das jetzt nach dt Millisekunden durch ein Coil-Ende Signal abgeschlossen wurde.
//
inline sAction* SelectFinishAction(unsigned long dt)
{
//BlinkLED(dt);
  if (dt < HiLIMIT_C2_LEAVE_LV) {		// LV-Stop (27ms)
    //PRINTLN("c2_H_LeaveLV");
    return c2_H_LeaveLV;
  }
  else if (IsInWindow_LVShoot(dt)  &&		// Auslsen im LV (56ms)
	   actionPtr != c1_L_Start		//  aber normales Shoot ausschlieen, das durch groe Blendenwerte auf hnliche Zeiten kommt!
  ) {
    //PRINTLN("c2_H_FinishLVShoot");
    return c2_H_FinishLVShoot;
  }
  else if (dt < HiLIMIT_C2_ENTER_LV) {		// EnterLV (50ms)
//BlinkLED(31 ms);
    //PRINTLN("c2_H_EnterLV");
    return c2_H_EnterLV;
  }
  else {																	// (700D 68 ms, 600D 77 ms:) nicht-LV-Shoot
    //PRINTLN("c2_H_FinishShoot");
    return c2_H_FinishShoot;			// Shoot (52..55ms)
  }
}

//#endif // EOS6D --------------------------------------------

