
//#if defined(EOS80D)

#undef	ROT2_INIT
#define	ROT2_INIT	LOW
# if defined (MOTORDRV)	
unsigned long stime;
# endif


sAction c1_L_Start[] = {			// Coil 2 aktiv
#ifdef EOS80D_VOLLEMU
	{ 0 ms,   MR2, HIGH },	  
#endif
	{ 6 ms,  ROT1, HIGH },
	{ 7 ms,  ROT2, HIGH },
	{13 ms,  ROT1, LOW  },
	{18 ms,  ROT1, HIGH },
#ifdef EOS80D_VOLLEMU
	{22 ms,  MR1 , LOW  },
#endif
	{26 ms,  ROT2, LOW  },
	{28 ms,  ROT3, LOW  },
	HALT_ACTION,		// weiter gehts wenn C2 Hi die Belichtung startet (bei der Spiegelvorauslsung hlt der Ablauf hier an)
};

// Start fr den LV:  Coil 2 ohne Coil 1 aktiv
//
sAction c2_L_StartForLV[] = {	
#ifdef EOS80D_VOLLEMU
	{ 0 ms,   MR2, HIGH},	  //vmtl. nicht ntig oder zu spt
#endif
	{13 ms,   ROT1, HIGH  },	// spter als bei Shoot!
	{14 ms,   ROT2, HIGH  },	//  dito
	{29 ms,  ROT1, LOW  },  // spter als bei Shoot!
#ifdef EOS80D_VOLLEMU
	{42 ms,  MR1 , LOW  },
#endif
	HALT_ACTION,		// weiter gehts mit C2 Hi
};

// Fortsetzung des regulren Shoot-Timings nach Coil-1/2 Hi
//
sAction c2_H_FinishShoot[] = {			// Coil 2 wird inaktiv
	{0 ms,   OPT2, LOW },	// -> Curtain ffnet und nach 2/3/4 ms geht OPT2 L/H/L. Bei sehr kurzen Belichtungen (< 1/250) --> Err30. Mit Timing 0/0/0 klappts bis 1/3200, im LV auch weiter.
	{0 ms,   OPT2, HIGH },	// Eigentlich werden fehlende Aktionen bei c1_H ggf. nachgezogen, aber bei der 80D gibt es dann wohl einen Konflikt mit Opt1
	{0 ms,   OPT2, LOW },
	LONGWAIT_ACTION,	// hier warten, bis Coil 1 Hi wird und die Belichtung beendet
#define c1_H_FinishShoot (c2_H_FinishShoot + 4)	
	// Coil 1 wird inaktiv: 
	// Curtain von Coil 2 hat schon vorher geffnet und 2 ms danach ging OPT2 Lo - falls die Belichtung
	//  > 5 ms war. Bei sehr kurzen Belichtungen wird der letzte Eintrag in c1_L_Start aber nicht 
	//  mehr ausgefhrt !
	{ 2 ms,  OPT1, LOW  },
	{ 3 ms,  OPT1, HIGH },
	{ 4 ms,  OPT1, LOW  },
#ifdef EOS80D_VOLLEMU
	{ 7 ms,  MR1 , HIGH }, 
#endif
	{ 20 ms, OPT1, HIGH },    // wg. Opt-Power=Off bei 15 ms ist der Zeitpunkt nicht zu erkennen,
	{ 20 ms, OPT2, HIGH },	  //  aber die Curtains werden wieder in Startpos. gebracht!
	{ 26 ms, ROT2, HIGH },
	{ 26 ms, ROT3, HIGH },
#ifdef EOS80D_VOLLEMU
	//{30 ms,  MR2 , LOW  },  // 26 ist zu kurz, 30 ok
	{40 ms,  MR2 , LOW  },	// 45 geht auch
#endif
	{ 48 ms, ROT2, LOW  },
	{ 57 ms, ROT1, LOW  },
	STOP_ACTION,
};

/////////////////////////////////////
// Start nach Shoot im LV:  Coil 2 ohne Coil 1 aktiv
//
sAction c2_L_StartInLVForLV[] = {	
	{14 ms,  ROT1, HIGH },
	{16 ms,  ROT2, HIGH },
	{30 ms,  ROT1, LOW  },
	HALT_ACTION,		// weiter gehts mit C2 Hi
};


//
// Start in LV: Coil 1+2 aktiv. Wird fr LV-Shoot und LV-Stop ausgef.
sAction c1_L_StartInLV[] = {			// Coil 2 aktiviert im LV
	{ 5 ms,  ROT1, HIGH },
	{14 ms,  ROT2, LOW  },
	{16 ms,  ROT3, LOW  }, 
	HALT_ACTION,
};

// Fortsetzung des LVShoot-Timings nach Coil-1/2 Hi
// !!! 6D: Klappt auch mit c2_H_FinishShoot: Spiegelsignale werden ignoriert. !!!
//
sAction c2_H_FinishLVShoot[] = {			// Coil 2 wird inaktiv
      //{4 ms,    OPT2, HIGH },	 OPT2 bleibt LOW!
	LONGWAIT_ACTION,				// hier warten, bis Coil 1 Hi wird und den Ablauf fortsetzt
#define c1_H_FinishLVShoot (c2_H_FinishLVShoot + 1)	
	{ 2 ms,  OPT1, LOW  },
	{ 3 ms,  OPT1, HIGH },
	{ 4 ms,  OPT1, LOW  },
	{15 ms,  OPT2, HIGH },  //  OPT2 wird hier oder nach Abschalten der OptPwr H
	{20 ms,  OPT1, HIGH },    // wg. Opt-Power=Off ist der Zeitpunkt nicht zu erkennen,
	{ 22 ms, ROT2, HIGH },
	{ 22 ms, ROT3, HIGH },
	{ 44 ms, ROT2, LOW  },
	{ 53 ms, ROT1, LOW  },
	STOP_ACTION,
};


// Beim Start des LV lst Coil 2 erst nach 64 ms (ohne Coil-1 Signal).
// Wenn anhand der C2_L Dauer vom normalen Shoot unterschieden wird, sind die ROT-Signale
//  schon zu weit, weil der Motor im LV-Leise-1 das Schlieen noch nicht vorspannt.
//  Das scheint zunchst kein Problem zu sein, aber beim Shoot im oder Stop des LV 
//  gibts Error 20. Die Pegel hier zu korrigieren geht aber nicht!
sAction c2_H_EnterLV[] = {	
	{2 ms,   OPT2, LOW },	// -> Curtain ffnet und nach 2 ms geht OPT2 Lo. 
	{3 ms,   OPT2, HIGH },	
	{5 ms,   OPT2, LOW },	// das ist nicht zu sehen, weil OptPwr abgesch. wird
	STOP_ACTION,
};
#define c1_H_EnterLV c2_H_EnterLV

// Nachdem das LV-Ende am Coil-2 Hi Timing erkannt wurde, mssen/knnen(?) 
//  die ROT-Pegel noch korrigiert werden, die hier frher kommen mssen,
//  aber noch auf dem Stand der reg. Auslsung nach 28 ms sind:
//
sAction c2_H_LeaveLV[] = {
	{ 2 ms,  OPT1, LOW  },
	{ 3 ms,  OPT1, HIGH },
	{ 4 ms,  OPT1, LOW  },
#ifdef EOS80D_VOLLEMU
	{ 7 ms,  MR1 , HIGH }, 
	{62 ms,  MR2 , LOW  },	// nach diesem Signal kommt Err20. Je mehr es verzgert wird, desto lnger ist die normale Anzeige sichtbar.
#endif
	{77 ms, OPT1, HIGH },    // wg. Opt-Power=Off ist der Zeitpunkt nicht zu erkennen,
	{77 ms, OPT2, HIGH },	  //  aber die Curtains werden wieder in Startpos. gebracht!
	{81 ms,  ROT2, HIGH },
	{81 ms,	 ROT3, HIGH },
	{102 ms, ROT2, LOW  },
	{111 ms, ROT1, LOW  },
#ifdef EOS80D_VOLLEMU
//{355 ms,  MR2 , LOW  },	// nach diesem Signal kommt Err20
#endif
	STOP_ACTION,						// fertig
};
#define c1_H_LeaveLV	c2_H_LeaveLV		// ohne Coil2: fr Coil1 identisch

///////////////////////////////////////

/*  80D Coil-Timing (LV im Leise-Modus 1):
	Modus     Coil 1  Coil 2
	------    ------  ------
	Shoot      47+t     47
	Shoot LV   54+t     54
	Enter LV    --      64	  // C1 wird fr (Re-)EnterLV nicht aktiviert. Da C2 immer zeitgleich
	ReEnter LV  --      38	  //  mit C1 startet, wird C2_H als Basissignal verwendet!
	Leave LV    21      21

  Die Zeiten ndern sich, wenn der Spiegel ausgebaut oder nicht eingehngt ist:
    Enter_LV kommt dann z.B. schon nach 52 atstt 64 ms!
  In der Voll-Emulation verschiebt sich das Ende von c2_L_StartForLV mit MR2 Low: offenbar wartet die Kamera auf den Spiegel.
    C2_H nach c1_L_Start kommt erst nach 108 statt 47 ms - obwohl MR2_L schon nach 18 ms angelegt wird !?!
	 
*/
// --> Grenzwerte zur Unterscheidung der Funktion bei C2_H:
#define HiLIMIT_C2_LVSHOOT	((54+5) ms)
#define HiLIMIT_C2_SHOOT	((47+5) ms)
#define HiLIMIT_C2_REENTER_LV	((38+6) ms)
#define LoLIMIT_C2_ENTER_LV	((64-4) ms)
#define HiLIMIT_C2_LEAVE_LV	((21+6) ms)

#define IsInWindow_EnterLV(dt)   (dt >= HiLIMIT_C2_LVSHOOT)
//#define IsInWindow_LVShoot(dt)   (dt <  HiLIMIT_C2_LVSHOOT  &&  dt >= HiLIMIT_C2_REENTER_LV)
#define IsInWindow_ReEnterLV(dt) (dt <= HiLIMIT_C2_REENTER_LV  &&  dt >= HiLIMIT_C2_LEAVE_LV)
#define IsInWindow_LeaveLV(dt)   (dt <  HiLIMIT_C2_LEAVE_LV)

// Nchste sAction Liste auswhlen fr die Fortsetzung eines Coil-Start Ereignisses,
//  das jetzt nach dt Millisekunden durch ein Coil-Ende Signal abgeschlossen wurde.
//
inline sAction* SelectFinishAction(unsigned long dt)
{
//PRINT_1000(dt);
  if (actionPtr == c2_L_StartForLV) {	// ber Timing klappts nicht, weil C2 in der Emulation nur 51..52ms L ist (statt 64)!!!
    //PRINTLN("c2_H_EnterLV");
    return c2_H_EnterLV;
  }
//#ifdef EOS80D_VOLLEMU	    // auch Spiegel wird emuliert: Timing verndert! Deshalb:
  if (actionPtr == c1_L_Start) {	// ber Timing klappts nicht, weil C2 in der Emulation nur 51..52ms L ist (statt 64)!!!
    //PRINTLN("c2_H_FinishShoot");
    return c2_H_FinishShoot;
  }
//#endif
  if (dt <  HiLIMIT_C2_LEAVE_LV) {	// LV-Stop: dT < 21+6 ms
    //PRINTLN("c2_H_LeaveLV");
    return c2_H_LeaveLV;
  }
  else if (dt <= HiLIMIT_C2_REENTER_LV) { // ReEnter LV: ~38
    //PRINTLN("c2_H_EnterLV");
    return c2_H_EnterLV;
  }
  else if (dt < HiLIMIT_C2_SHOOT) {	// vermutlich zu kurz fr groe Blendenwerte "80D_BLENDE"
					// evtl. etwas erhhen und sicherstellen, dass nicht im LV
					// (wg. Konflikt mit HiLIMIT_C2_LVSHOOT) und < 
    // --> testen:
//else if (dt < LoLIMIT_C2_ENTER_LV  &&  actionPtr != c1_L_StartInLV) {
    //PRINTLN("c2_H_FinishShoot");
    return c2_H_FinishShoot;		// Shoot (47ms)
  }
  else if (dt <  HiLIMIT_C2_LVSHOOT) {	// Auslsen im LV: (38+6) ms < dt <  ((54+5) ms)
    //PRINTLN("c2_H_FinishLVShoot");
    return c2_H_FinishLVShoot;
  }
  else { //if (dt >= HiLIMIT_C2_LVSHOOT) 
    //PRINTLN("c2_H_EnterLV");
    return c2_H_EnterLV;
  }
/*
  if (IsInWindow_LeaveLV(dt)) {		// LV-Stop: dT < 21+6 ms
    //PRINTLN("c2_H_LeaveLV");
    return c2_H_LeaveLV;
  }
  else if (IsInWindow_LVShoot(dt)) {	// Auslsen im LV: (38+6) ms < dt <  ((54+5) ms)
    //PRINTLN("c2_H_FinishLVShoot");
    return c2_H_FinishLVShoot;
  }
  else if (IsInWindow_EnterLV(dt) || IsInWindow_ReEnterLV(dt)) {			
//BlinkLED(31 ms);
    //PRINTLN("c2_H_EnterLV");
    return c2_H_EnterLV;
  }
  else {																	// (700D 68 ms, 600D 77 ms:) nicht-LV-Shoot
    //PRINTLN("c2_H_FinishShoot");
    return c2_H_FinishShoot;		// Shoot (52ms)
  }
*/
}

// Erste sAction Liste auswhlen fr ein Coil-Start Ereignis
//
inline sAction* SelectStartAction()
{
  if (digitalRead(TRIGGER1) == TRIGGER1_ACTIVE) {   // auch Coil 1 ist aktiv: Auslsen oder LV-Stop
    if (actionPtr == c2_H_EnterLV) {	  // zuletzt in den LV gegangen?
      //PRINTLN("c1_L_StartInLV");
      return c1_L_StartInLV;
    }
    else {
      //PRINTLN("c1_L_Start");
      //BlinkLED(14 ms);
      return c1_L_Start;
    }
  }
  else {		  // ohne Coil 1: LV-Start - ist innerhalb nach LVShoot oder LV-ReEnter mglich
    if (actionPtr == c2_H_EnterLV  ||  actionPtr == c2_H_FinishLVShoot) {		  
      //PRINTLN("c2_L_StartInLVForLV");
      return c2_L_StartInLVForLV;
    }
    else {
      //PRINTLN("c2_L_StartForLV");
      return c2_L_StartForLV;
    }
  }
}

//#endif // EOS80D --------------------------------------------
