#ifndef debugmsg_h_
#define debugmsg_h_


inline void ToggleLED()
{
  digitalWrite(LED_BUILTIN, !digitalRead(LED_BUILTIN));   // LED umschalten
}

#if defined(DEBUG_SLOW)
#define ToggleDebugLED()	ToggleLED()
#define DebugSlowdown(t)	((t))// >> 6)        // /64: 10ms -> 0.64s
#else
#define ToggleDebugLED()
#define DebugSlowdown(t)	(t)
#endif



#if defined(DEBUG_BLINK)
void BlinkLED(long n);
bool DoBlinkLED();
#else
inline void BlinkLED(long) {}
inline bool DoBlinkLED()   {return true;}
#endif



#if defined(SERIAL_DEBUG)
#define PRINT(a)    Serial.print(a)
#define PRINTLN(a)  Serial.println(a)
#define PRINT_1000(a)    Serial.print(a/1000)

inline void SetupSerialDebug() 
{
  Serial.begin(SERIAL_DEBUG);
  PRINTLN("");
  PRINTLN("Starte ...");
}

#else
# if defined(BLUE_DEBUG)// && defined(INTERVALL_TIMER)
#  define PRINT(a)	  dbgPrint(a)
#  define PRINTLN(a)	  dbgPrintln(a)
#  define PRINT_1000(a)   dbgPrint(a/1000)
# else
#  define PRINT(a)
#  define PRINTLN(a)
#  define PRINT_1000(a)
# endif
inline void SetupSerialDebug() {}
#endif


inline void SetupDebug() 
{
  static int isinit = 0;
  if (isinit == 0) {
    isinit = 1;
    SetupSerialDebug();
    #if defined(DEBUG_BLINK)
    blinkCount = 0;
    #endif
    #if  defined(DEBUG_SLOW) ||  defined(DEBUG_BLINK)
    pinMode(LED_BUILTIN, OUTPUT);
    #endif
  }
}


#endif
