#include "debugmsg.h"


#if defined(DEBUG_BLINK)
int blinkCount;
unsigned long nextBlink;


void BlinkLED(long n)
{
  if (blinkCount <= 0) BlinkLEDForced(n);
}

void BlinkLEDForced(long n)
{
  blinkCount = n / 1000;
  nextBlink = micros();
  digitalWrite(LED_BUILTIN, 0);
}

// Ggf. LED umschalten zum Blinken
//
// Rückgabe: true, wenn alles erledigt ist
//
bool DoBlinkLED()
{
  if (blinkCount <= 0) {
    return true;
  }
  //if (triggerEvent != evNone) return true;
  if (micros() < nextBlink) {
    return false;					// noch warten
  }
  bool nxt = !digitalRead(LED_BUILTIN);
  digitalWrite(LED_BUILTIN, nxt);
  if (blinkCount >= 100) {				// 100ms
    if (nxt) {						//  an
      nextBlink = micros() + 500000L;
    }
    else {
      nextBlink = micros() + 200000L;
      blinkCount -= 100;
      if (blinkCount < 100) nextBlink += 200000L;	// lange Pause
    }
    return false;
  }
  if (blinkCount >= 10) {				// Zehner
    if (nxt) {						//  an
      nextBlink = micros() + 300000L;
    }
    else {
      nextBlink = micros() + 200000L;
      blinkCount -= 10;
      if (blinkCount < 10) nextBlink += 200000L;	// lange Pause
    }
    return false;
  }
  if (blinkCount > 0) {				// Einer
    if (nxt) {									//  an
      nextBlink = micros() + 100000L;
    }
    else {
      blinkCount -= 1;
      nextBlink = micros() + 200000L;
    }
  }
  return blinkCount <= 0;		// fertig, wenn 0 erreicht
}
#endif


