/////////////////////////////////////////////////////////////////////////////////////////////
//	Pin-Belegung für Arduino Intervall-Timer mit Bluetooth-Modul
//
//       17.05.2024	                             Erwin Lotter
/////////////////////////////////////////////////////////////////////////////////////////////
#ifndef pins_h_
#define pins_h_

// Serial() für Bluetooth-Anbindung verwenden:
// (Achtung: Beim Upload darf Tx des Bluetooth-Moduls nicht eingesteckt sein!)
// 
//#define BLUESERIAL_IN_SOFTWARE 0  

#ifndef BLUESERIAL_IN_SOFTWARE	  // (Übergeordnete Definition nur für einzelne Quellcodedatei möglich! --> AstroShootBlue())
#define BLUESERIAL_IN_SOFTWARE 1  //  Serial() für Bluetooth-Anbindung reserviert, wenn 0
#endif

#ifndef NEXT_FREE_PIN		  // (Übergeordnete Definition nur für einzelne Quellcodedatei möglich!)
#include "camera.h"		  // get pins used for select camera model
#endif

// Arduino-Pins:
#define SHOOT_LINE	NEXT_FREE_PIN	// Auslösung, geht an Auslöser der Kamera
#if NEXT_FREE_PIN > 13
#error Not enough free pins on Arduino Nano/Pro Mini for AstroShoot
#endif

#if BLUESERIAL_IN_SOFTWARE
# if NEXT_FREE_PIN > 11
#  undef BLUESERIAL_IN_SOFTWARE
#  define BLUESERIAL_IN_SOFTWARE 0
#  pragma warning "Not enough free pins on Arduino Nano/Pro Mini for SoftwareSerial. Using Serial instead."
# else
# define blueRX	(NEXT_FREE_PIN+1)	// RX-Leitung zur Anbindung des Bluetooth-Moduls (HC-05):
					//  muss Interrupt-fähig sein! Pin 10 geht wohl bei allen Prozessoren.
# define blueTX	(NEXT_FREE_PIN+2)	// TX-Leitung zum RX des Bluetooth-Moduls, über Vorwiderstand falls 5V-Arduino
  //
  // Wenn möglich sollten die Pins 11, 12 und 13 Ausgänge sein, damit der Arduino auch bei
  //  daran angeschlossener Peripherie (die hier dann Eingänge hat) programmiert werden kann.
# endif
#endif

#if !BLUESERIAL_IN_SOFTWARE
# undef SERIAL_DEBUG		  // Serial() für Bluetooth-Anbindung reserviert
#endif // !BLUESERIAL_IN_SOFTWARE


#endif
